package com.loafle.overflow.crawler.result;

import com.loafle.overflow.crawler.config.Item;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * Created by root on 17. 4. 25.
 */
public abstract class OFResultSet {
    // properties
    protected Item item;
    protected List<List<String>> rows;
    protected Map<String, Integer> meta = null;

    public Map<String, Integer> getMeta() {
        return meta;
    }

    public void setMeta(Map<String, Integer> meta) {
        this.meta = meta;
    }

    public List<List<String>> getRows() {
        return rows;
    }

    public void setRows(List<List<String>> rows) {
        this.rows = rows;
    }

    public Item getItem() {
        return item;
    }

    public void setItem(Item item) {
        this.item = item;
    }

    // methods
    static public OFResultSet newInstance(Item item) {
        String type = (String) item.getQuery().getQueryInfo().get("parseDirection");
        if (type.equals("row")) {
            return new OFResultSetRow(item);
        } else {
            return new OFResultSetCol(item);
        }
    }


    public OFResultSet(Item item) {
        this.item = item;
        this.rows = new ArrayList<>();
        this.setMeta();
    }

    public void addRow(List<String> row) {
        rows.add(row);
    }


    public Map<String,String> getData() {
       return parse();
    }

    // abstracts
    public abstract void setMeta();
    public abstract Map<String, String> parse();


}
